import { useGraphqlState } from "./useGraphqlState.mjs";
import { getEndpoint } from "./shared.mjs";
export function performRequest(operation, operationName, method, options) {
  const state = useGraphqlState();
  return $fetch(getEndpoint(operation, operationName), {
    ...state && state.fetchOptions ? state.fetchOptions : {},
    ...options,
    method
  }).then((v) => {
    return {
      data: v.data,
      errors: v.errors || []
    };
  });
}
