import { GraphqlMiddlewareQueryName, GetQueryArgs, QueryObjectArgs, GetQueryResult, GraphqlMiddlewareMutationName, GetMutationArgs, MutationObjectArgs, GetMutationResult } from './shared';
import type { GraphqlMiddlewareQuery, GraphqlMiddlewareMutation } from '#build/nuxt-graphql-middleware';
/**
 * Performs a GraphQL query.
 */
export declare function useGraphqlQuery<T extends GraphqlMiddlewareQueryName>(...args: GetQueryArgs<T, GraphqlMiddlewareQuery> | [QueryObjectArgs<T, GraphqlMiddlewareQuery>]): Promise<GetQueryResult<T, GraphqlMiddlewareQuery>>;
/**
 * Performs a GraphQL mutation.
 */
export declare function useGraphqlMutation<T extends GraphqlMiddlewareMutationName>(...args: GetMutationArgs<T, GraphqlMiddlewareMutation> | [MutationObjectArgs<T, GraphqlMiddlewareMutation>]): Promise<GetMutationResult<T, GraphqlMiddlewareMutation>>;
