import type { FetchOptions } from 'ofetch';
import type { GraphqlMiddlewareQuery, GraphqlMiddlewareMutation } from '#build/nuxt-graphql-middleware';
export type GraphqlMiddlewareQueryName = keyof GraphqlMiddlewareQuery;
export type GraphqlMiddlewareMutationName = keyof GraphqlMiddlewareMutation;
export type GetQueryArgs<T extends GraphqlMiddlewareQueryName, M extends GraphqlMiddlewareQuery> = M[T][0] extends null ? [T] : M[T][1] extends false ? [T, M[T][0]] : [T, M[T][0]?];
export type GetMutationArgs<T extends GraphqlMiddlewareMutationName, M extends GraphqlMiddlewareMutation> = M[T][0] extends null ? [T] : M[T][1] extends false ? [T, M[T][0]] : [T, M[T][0]?];
export type GraphqlResponse<T> = {
    data: T;
    errors: any[];
};
export type GetQueryResult<T extends GraphqlMiddlewareQueryName, M extends GraphqlMiddlewareQuery> = M[T] extends undefined ? undefined : GraphqlResponse<M[T][2]>;
export type GetMutationResult<T extends GraphqlMiddlewareMutationName, M extends GraphqlMiddlewareMutation> = M[T] extends undefined ? undefined : GraphqlResponse<M[T][2]>;
export declare function getEndpoint(operation: string, operationName: string): string;
export type QueryObjectArgs<T extends GraphqlMiddlewareQueryName, M extends GraphqlMiddlewareQuery> = M[T][0] extends null ? {
    name: T;
    fetchOptions?: FetchOptions;
    variables?: null;
} : {
    name: T;
    variables: M[T][0];
    fetchOptions?: FetchOptions;
};
export type MutationObjectArgs<T extends GraphqlMiddlewareMutationName, M extends GraphqlMiddlewareMutation> = M[T][0] extends null ? {
    name: T;
    variables?: null;
    fetchOptions?: FetchOptions;
} : {
    name: T;
    variables: M[T][0];
    fetchOptions?: FetchOptions;
};
